# hradrv.spec - hradrv package for Driver Update Model
#
# Copyright (C) 2009,2011, Hitachi, Ltd.
# (C) Copyright 2001-2011   TOSHIBA SOLUTIONS CORPORATION
#
# Based on test.spec by Jon Masters <jcm@redhat.com>
# at http://www.kerneldrivers.org/RedHatKernelModulePackages

# kversion: target kernel version as 'uname -r', e.g., 2.6.18-8.el5xen.
%{!?kversion: %define kversion %(uname -r)}

# kverrel: kversion where variant suffix (xen and PAE) is removed.
#%{expand:%define kverrel %( shopt -s extglob; foo=%{kversion}; echo ${foo%%%%@(xen|PAE)} )}

# kvariant: variant suffix itself.  Can be an empty string.
#%{expand:%define kvariant %( foo=%{kversion}; echo ${foo#%{kverrel}} )}

# kvar: yields '-' plus kvariant if kvariant is non-null.  Null otherwise.
#%{expand:%define kvar %( _kv=%{kvariant}; echo -n ${_kv:+-$_kv} )}

# kdevel: name of matching kernel-devel package.
#%{expand:%define kdevel kernel%{kvar}-devel-%{_target_cpu}}

# ksrc: kernel source directory, provided by matching kernel-devel package.
#%{expand:%define ksrc %{_usrsrc}/kernels/%{kverrel}%{kvar}-%{_target_cpu}}

ExclusiveArch: i686 x86_64

Name:       hradrv
%ifarch x86_64
Version: 2.6.4.106
%else
Version: 2.6.4.106
%endif
Release:    1%{?dist}
Summary:    Hitachi Raid Adapter Driver
License:    GPL
Group:      System Environment/Drivers
Source0:       %{name}-%{version}.tar.bz2
Source1:       %{name}.files
Source2:       %{name}.conf
Source3:       hrainst.el6.sh
BuildRoot:     %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildRequires: %kernel_module_package_buildreqs

%kernel_module_package -f %{SOURCE1} default

%description 
A hradrv package for Driver Update Model.

%prep
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT/opt/hitachi/drivers/hra
mkdir -p $RPM_BUILD_ROOT/opt/hitachi/drivers/hra

%setup -n hradrv-%{version}
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
for flavor in %flavors_to_build; do
     rm -rf obj/$flavor
     cp -r source obj/$flavor
     make -C %{kernel_source $flavor} M=$PWD/obj/$flavor
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{name}
for flavor in %flavors_to_build ; do
     make -C %{kernel_source $flavor} modules_install \
               M=$PWD/obj/$flavor
     # Cleanup unnecessary kernel-generated module dependency files.
     find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done

install -m 644 -D %{SOURCE2} $RPM_BUILD_ROOT/etc/depmod.d/%{name}.conf
install -m 644 -D %{SOURCE3} $RPM_BUILD_ROOT/opt/hitachi/drivers/hra/hrainst.el6.sh

# In post, it is better to list modules explicitly.
%post
	$RPM_BUILD_ROOT/opt/hitachi/drivers/hra/hrainst.el6.sh install

if [ -e /boot/System.map-%{kversion} ]; then
    /sbin/depmod -aeF /boot/System.map-%{kversion} %{kversion} > /dev/null || :
fi

if [ -f /lib/modules/%{kversion}/extra/hradrv/hraslog_link.ko.hraslog.rename ]; then
	if [ -x /sbin/weak-modules ]; then
		cat <<EOF | /sbin/weak-modules --no-initrd --add-modules
/lib/modules/%{kversion}/extra/hradrv/hradrv.ko
EOF
	fi
	rm /lib/modules/%{kversion}/extra/hradrv/hraslog_link.ko
	if [ -x /sbin/weak-modules ]; then
		cat <<EOF | /sbin/weak-modules --remove-modules
/lib/modules/%{kversion}/extra/hradrv/hraslog_link.ko
EOF
	fi
else
	if [ -x /sbin/weak-modules ]; then
		cat <<EOF | /sbin/weak-modules --add-modules
/lib/modules/%{kversion}/extra/hradrv/hradrv.ko
EOF
	fi
fi

# In preun, it is better to list modules explicitly.
%preun
	$RPM_BUILD_ROOT/opt/hitachi/drivers/hra/hrainst.el6.sh uninstall

# In postun, it is better to list modules explicitly.
%postun
/sbin/depmod -aF /boot/System.map-%{kversion} %{kversion} &> /dev/null || :
if [ -x /sbin/weak-modules ]; then
    cat <<EOF | /sbin/weak-modules --remove-modules
/lib/modules/%{kversion}/extra/hradrv/hradrv.ko
EOF
fi

# In files, do not list directories if not yours.
%files
%defattr(644,root,root,755)
/lib/modules/%{kversion}/extra/hradrv/hradrv.ko
%dir /lib/modules/%{kversion}/extra/hradrv
%defattr(755,root,root,755)
/opt/hitachi/drivers/hra/*

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Aug 16 2011 Yoshihiro Toyohara <yoshihiro.toyohara.qs@hitachi.com>
- Revision 2.6.4.106 support
* Fri Sep 26 2008 Keisuke Inoue <keisuke.inoue.se@hitachi.com>
- Support Red Hat Enterprise Linux 5.
